/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

///
/// This file was automatically generated from the AMQP specification.
/// Do not edit.
///


#include "Session_0_10.h"
#include "qpid/framing/all_method_bodies.h"

namespace qpid {
namespace client {
namespace no_keyword {

using namespace framing;

Completion Session_0_10::executionSync() {
    return Completion(impl->send(ExecutionSyncBody(ProtocolVersion())), impl);
}

Completion Session_0_10::executionResult(const SequenceNumber& commandId, const string& value) {
    return Completion(impl->send(ExecutionResultBody(ProtocolVersion(), commandId, value)), impl);
}

Completion Session_0_10::executionException(uint16_t errorCode, const SequenceNumber& commandId, uint8_t classCode, uint8_t commandCode, uint8_t fieldIndex, const string& description, const FieldTable& errorInfo) {
    return Completion(impl->send(ExecutionExceptionBody(ProtocolVersion(), errorCode, commandId, classCode, commandCode, fieldIndex, description, errorInfo)), impl);
}

Completion Session_0_10::messageTransfer(const string& destination, uint8_t acceptMode, uint8_t acquireMode, const MethodContent& content) {
    return Completion(impl->send(MessageTransferBody(ProtocolVersion(), destination, acceptMode, acquireMode), content), impl);
}

Completion Session_0_10::messageAccept(const SequenceSet& transfers) {
    return Completion(impl->send(MessageAcceptBody(ProtocolVersion(), transfers)), impl);
}

Completion Session_0_10::messageReject(const SequenceSet& transfers, uint16_t code, const string& text) {
    return Completion(impl->send(MessageRejectBody(ProtocolVersion(), transfers, code, text)), impl);
}

Completion Session_0_10::messageRelease(const SequenceSet& transfers, bool setRedelivered) {
    return Completion(impl->send(MessageReleaseBody(ProtocolVersion(), transfers, setRedelivered)), impl);
}

TypedResult<qpid::framing::MessageAcquireResult> Session_0_10::messageAcquire(const SequenceSet& transfers) {
    return TypedResult<qpid::framing::MessageAcquireResult>(impl->send(MessageAcquireBody(ProtocolVersion(), transfers)), impl);
}

TypedResult<qpid::framing::MessageResumeResult> Session_0_10::messageResume(const string& destination, const string& resumeId) {
    return TypedResult<qpid::framing::MessageResumeResult>(impl->send(MessageResumeBody(ProtocolVersion(), destination, resumeId)), impl);
}

Completion Session_0_10::messageSubscribe(const string& queue, const string& destination, uint8_t acceptMode, uint8_t acquireMode, bool exclusive, const string& resumeId, uint64_t resumeTtl, const FieldTable& arguments) {
    return Completion(impl->send(MessageSubscribeBody(ProtocolVersion(), queue, destination, acceptMode, acquireMode, exclusive, resumeId, resumeTtl, arguments)), impl);
}

Completion Session_0_10::messageCancel(const string& destination) {
    return Completion(impl->send(MessageCancelBody(ProtocolVersion(), destination)), impl);
}

Completion Session_0_10::messageSetFlowMode(const string& destination, uint8_t flowMode) {
    return Completion(impl->send(MessageSetFlowModeBody(ProtocolVersion(), destination, flowMode)), impl);
}

Completion Session_0_10::messageFlow(const string& destination, uint8_t unit, uint32_t value) {
    return Completion(impl->send(MessageFlowBody(ProtocolVersion(), destination, unit, value)), impl);
}

Completion Session_0_10::messageFlush(const string& destination) {
    return Completion(impl->send(MessageFlushBody(ProtocolVersion(), destination)), impl);
}

Completion Session_0_10::messageStop(const string& destination) {
    return Completion(impl->send(MessageStopBody(ProtocolVersion(), destination)), impl);
}

Completion Session_0_10::txSelect() {
    return Completion(impl->send(TxSelectBody(ProtocolVersion())), impl);
}

Completion Session_0_10::txCommit() {
    return Completion(impl->send(TxCommitBody(ProtocolVersion())), impl);
}

Completion Session_0_10::txRollback() {
    return Completion(impl->send(TxRollbackBody(ProtocolVersion())), impl);
}

Completion Session_0_10::dtxSelect() {
    return Completion(impl->send(DtxSelectBody(ProtocolVersion())), impl);
}

TypedResult<qpid::framing::XaResult> Session_0_10::dtxStart(const Xid& xid, bool join, bool resume) {
    return TypedResult<qpid::framing::XaResult>(impl->send(DtxStartBody(ProtocolVersion(), xid, join, resume)), impl);
}

TypedResult<qpid::framing::XaResult> Session_0_10::dtxEnd(const Xid& xid, bool fail, bool suspend) {
    return TypedResult<qpid::framing::XaResult>(impl->send(DtxEndBody(ProtocolVersion(), xid, fail, suspend)), impl);
}

TypedResult<qpid::framing::XaResult> Session_0_10::dtxCommit(const Xid& xid, bool onePhase) {
    return TypedResult<qpid::framing::XaResult>(impl->send(DtxCommitBody(ProtocolVersion(), xid, onePhase)), impl);
}

Completion Session_0_10::dtxForget(const Xid& xid) {
    return Completion(impl->send(DtxForgetBody(ProtocolVersion(), xid)), impl);
}

TypedResult<qpid::framing::DtxGetTimeoutResult> Session_0_10::dtxGetTimeout(const Xid& xid) {
    return TypedResult<qpid::framing::DtxGetTimeoutResult>(impl->send(DtxGetTimeoutBody(ProtocolVersion(), xid)), impl);
}

TypedResult<qpid::framing::XaResult> Session_0_10::dtxPrepare(const Xid& xid) {
    return TypedResult<qpid::framing::XaResult>(impl->send(DtxPrepareBody(ProtocolVersion(), xid)), impl);
}

TypedResult<qpid::framing::DtxRecoverResult> Session_0_10::dtxRecover() {
    return TypedResult<qpid::framing::DtxRecoverResult>(impl->send(DtxRecoverBody(ProtocolVersion())), impl);
}

TypedResult<qpid::framing::XaResult> Session_0_10::dtxRollback(const Xid& xid) {
    return TypedResult<qpid::framing::XaResult>(impl->send(DtxRollbackBody(ProtocolVersion(), xid)), impl);
}

Completion Session_0_10::dtxSetTimeout(const Xid& xid, uint32_t timeout) {
    return Completion(impl->send(DtxSetTimeoutBody(ProtocolVersion(), xid, timeout)), impl);
}

Completion Session_0_10::exchangeDeclare(const string& exchange, const string& type, const string& alternateExchange, bool passive, bool durable, bool autoDelete, const FieldTable& arguments) {
    return Completion(impl->send(ExchangeDeclareBody(ProtocolVersion(), exchange, type, alternateExchange, passive, durable, autoDelete, arguments)), impl);
}

Completion Session_0_10::exchangeDelete(const string& exchange, bool ifUnused) {
    return Completion(impl->send(ExchangeDeleteBody(ProtocolVersion(), exchange, ifUnused)), impl);
}

TypedResult<qpid::framing::ExchangeQueryResult> Session_0_10::exchangeQuery(const string& name) {
    return TypedResult<qpid::framing::ExchangeQueryResult>(impl->send(ExchangeQueryBody(ProtocolVersion(), name)), impl);
}

Completion Session_0_10::exchangeBind(const string& queue, const string& exchange, const string& bindingKey, const FieldTable& arguments) {
    return Completion(impl->send(ExchangeBindBody(ProtocolVersion(), queue, exchange, bindingKey, arguments)), impl);
}

Completion Session_0_10::exchangeUnbind(const string& queue, const string& exchange, const string& bindingKey) {
    return Completion(impl->send(ExchangeUnbindBody(ProtocolVersion(), queue, exchange, bindingKey)), impl);
}

TypedResult<qpid::framing::ExchangeBoundResult> Session_0_10::exchangeBound(const string& exchange, const string& queue, const string& bindingKey, const FieldTable& arguments) {
    return TypedResult<qpid::framing::ExchangeBoundResult>(impl->send(ExchangeBoundBody(ProtocolVersion(), exchange, queue, bindingKey, arguments)), impl);
}

Completion Session_0_10::queueDeclare(const string& queue, const string& alternateExchange, bool passive, bool durable, bool exclusive, bool autoDelete, const FieldTable& arguments) {
    return Completion(impl->send(QueueDeclareBody(ProtocolVersion(), queue, alternateExchange, passive, durable, exclusive, autoDelete, arguments)), impl);
}

Completion Session_0_10::queueDelete(const string& queue, bool ifUnused, bool ifEmpty) {
    return Completion(impl->send(QueueDeleteBody(ProtocolVersion(), queue, ifUnused, ifEmpty)), impl);
}

Completion Session_0_10::queuePurge(const string& queue) {
    return Completion(impl->send(QueuePurgeBody(ProtocolVersion(), queue)), impl);
}

TypedResult<qpid::framing::QueueQueryResult> Session_0_10::queueQuery(const string& queue) {
    return TypedResult<qpid::framing::QueueQueryResult>(impl->send(QueueQueryBody(ProtocolVersion(), queue)), impl);
}

}}} // namespace qpid::client::no_keyword

