
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/log/Statement.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/management/Manageable.h" 
#include "Agent.h"


using namespace qpid::management;
using namespace qpid::sys;
using namespace qpid::framing;
using           std::string;

string  Agent::packageName  = string ("qpid");
string  Agent::className    = string ("agent");
uint8_t Agent::md5Sum[16]   =
    {0x98,0x9a,0xeb,0x26,0xf4,0x5,0x1c,0xe4,0x5b,0x93,0xd5,0x9b,0x10,0x3a,0x83,0x19};

Agent::Agent (Manageable* _core) :
    ManagementObject(_core)
    
{
    

}

Agent::~Agent () {}

namespace {
    const string NAME("name");
    const string TYPE("type");
    const string ACCESS("access");
    const string INDEX("index");
    const string UNIT("unit");
    const string MIN("min");
    const string MAX("max");
    const string MAXLEN("maxlen");
    const string DESC("desc");
    const string ARGCOUNT("argCount");
    const string ARGS("args");
    const string DIR("dir");
    const string DEFAULT("default");
}

void Agent::writeSchema (Buffer& buf)
{
    FieldTable ft;

    // Schema class header:
    buf.putShortString (packageName); // Package Name
    buf.putShortString (className);   // Class Name
    buf.putBin128      (md5Sum);      // Schema Hash
    buf.putShort       (4); // Config Element Count
    buf.putShort       (0); // Inst Element Count
    buf.putShort       (0); // Method Count
    buf.putShort       (0); // Event Count

    // Config Elements
    ft = FieldTable ();
    ft.setString (NAME,   "sessionId");
    ft.setInt    (TYPE,   TYPE_UUID);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (INDEX,  1);
    ft.setString (DESC,   "Session ID for Agent");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "label");
    ft.setInt    (TYPE,   TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (INDEX,  0);
    ft.setString (DESC,   "Label for agent");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "registeredTo");
    ft.setInt    (TYPE,   TYPE_REF);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (INDEX,  0);
    ft.setString (DESC,   "Broker agent is registered to");
    buf.put (ft);

    ft = FieldTable ();
    ft.setString (NAME,   "sysId");
    ft.setInt    (TYPE,   TYPE_UUID);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (INDEX,  0);
    ft.setString (DESC,   "Identifier of system where agent resides");
    buf.put (ft);


    // Inst Elements

    // Methods

    // Events

}

void Agent::writeConfig (Buffer& buf)
{
    sys::RWlock::ScopedRlock readLock (accessLock);
    configChanged = false;

    writeTimestamps (buf);
    sessionId.encode (buf);
    buf.putShortString (label);
    buf.putLongLong (registeredTo);
    sysId.encode (buf);

}

void Agent::writeInstrumentation (Buffer& buf, bool skipHeaders)
{
    sys::RWlock::ScopedWlock writeLock (accessLock);
    instChanged = false;

    if (!skipHeaders)
        writeTimestamps (buf);


    // Maintenance of hi-lo statistics

}

void Agent::doMethod (string, Buffer&, Buffer& outBuf)
{
    Manageable::status_t status = Manageable::STATUS_UNKNOWN_METHOD;

    outBuf.putLong        (status);
    outBuf.putShortString (Manageable::StatusText (status));
}

