
#ifndef _MANAGEMENT_AGENT_
#define _MANAGEMENT_AGENT_

//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/ManagementObject.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/Uuid.h"

namespace qpid {
namespace management {

class Agent : public ManagementObject
{
  private:

    static std::string packageName;
    static std::string className;
    static uint8_t     md5Sum[16];

    // Configuration Elements
    framing::Uuid sessionId;
    std::string label;
    uint64_t registeredTo;
    framing::Uuid sysId;

    // Instrumentation Elements

    // Private Methods
    static void writeSchema   (qpid::framing::Buffer& buf);
    void writeConfig          (qpid::framing::Buffer& buf);
    void writeInstrumentation (qpid::framing::Buffer& buf,
                               bool skipHeaders = false);
    void doMethod             (std::string            methodName,
                               qpid::framing::Buffer& inBuf,
                               qpid::framing::Buffer& outBuf);
    writeSchemaCall_t getWriteSchemaCall (void) { return writeSchema; }

    // Stub for getInstChanged.  There are no inst elements
    bool getInstChanged (void) { return false; }

  public:

    friend class PackageQpid;
    typedef boost::shared_ptr<Agent> shared_ptr;

    Agent (Manageable* coreObject);
    ~Agent (void);

    std::string getPackageName (void) { return packageName; }
    std::string getClassName   (void) { return className; }
    uint8_t*    getMd5Sum      (void) { return md5Sum; }

    // Method IDs

    // Accessor Methods
    inline void set_sessionId (framing::Uuid val){
        sys::RWlock::ScopedWlock writeLock (accessLock);
        sessionId = val;
        configChanged = true;
    }
    inline void set_label (std::string val){
        sys::RWlock::ScopedWlock writeLock (accessLock);
        label = val;
        configChanged = true;
    }
    inline void set_registeredTo (uint64_t val){
        sys::RWlock::ScopedWlock writeLock (accessLock);
        registeredTo = val;
        configChanged = true;
    }
    inline void set_sysId (framing::Uuid val){
        sys::RWlock::ScopedWlock writeLock (accessLock);
        sysId = val;
        configChanged = true;
    }

};

}}
            

#endif  /*!_MANAGEMENT_AGENT_*/
