
#ifndef _MANAGEMENT_PRODUCER_
#define _MANAGEMENT_PRODUCER_

//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/ManagementObject.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/Uuid.h"

namespace qpid {
namespace management {

class Producer : public ManagementObject
{
  private:

    static std::string packageName;
    static std::string className;
    static uint8_t     md5Sum[16];

    // Configuration Elements
    uint64_t destinationRef;
    uint64_t exchangeRef;

    // Instrumentation Elements
    uint64_t  msgsProduced;
    uint64_t  bytesProduced;

    // Private Methods
    static void writeSchema   (qpid::framing::Buffer& buf);
    void writeConfig          (qpid::framing::Buffer& buf);
    void writeInstrumentation (qpid::framing::Buffer& buf,
                               bool skipHeaders = false);
    void doMethod             (std::string            methodName,
                               qpid::framing::Buffer& inBuf,
                               qpid::framing::Buffer& outBuf);
    writeSchemaCall_t getWriteSchemaCall (void) { return writeSchema; }


  public:

    friend class PackageQpid;
    typedef boost::shared_ptr<Producer> shared_ptr;

    Producer (Manageable* coreObject, uint64_t _destinationRef, uint64_t _exchangeRef);
    ~Producer (void);

    std::string getPackageName (void) { return packageName; }
    std::string getClassName   (void) { return className; }
    uint8_t*    getMd5Sum      (void) { return md5Sum; }

    // Method IDs

    // Accessor Methods
    inline void inc_msgsProduced (uint64_t by = 1){
        sys::RWlock::ScopedWlock writeLock (accessLock);
        msgsProduced += by;
        instChanged = true;
    }
    inline void dec_msgsProduced (uint64_t by = 1){
        sys::RWlock::ScopedWlock writeLock (accessLock);
        msgsProduced -= by;
        instChanged = true;
    }
    inline void set_msgsProduced (uint64_t val){
        sys::RWlock::ScopedWlock writeLock (accessLock);
        msgsProduced = val;
        instChanged = true;
    }
    inline void inc_bytesProduced (uint64_t by = 1){
        sys::RWlock::ScopedWlock writeLock (accessLock);
        bytesProduced += by;
        instChanged = true;
    }
    inline void dec_bytesProduced (uint64_t by = 1){
        sys::RWlock::ScopedWlock writeLock (accessLock);
        bytesProduced -= by;
        instChanged = true;
    }
    inline void set_bytesProduced (uint64_t val){
        sys::RWlock::ScopedWlock writeLock (accessLock);
        bytesProduced = val;
        instChanged = true;
    }

};

}}
            

#endif  /*!_MANAGEMENT_PRODUCER_*/
